/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					  "title" : "Compare Lists",
						"description" : "Compares the items of 2 lists and outputs the matching items as well as the differences as 2 index lists. This supposes both lists have the same amount of items though.",
					  "keywords" : [ "==", "same", "identical", "equivalent", "match", "compare" ],
					  "version" : "1.0.0",
					  "genericTypes" : {
						  "VuoGenericType1" : {
							  "compatibleTypes" : [
								  "VuoBoolean", "VuoColor", "VuoImage", "VuoInteger",
								  "VuoPoint2d", "VuoPoint3d", "VuoPoint4d",
								  "VuoReal", "VuoScreen", "VuoText",
								  "VuoArtNetInputDevice", "VuoArtNetOutputDevice",
								  "VuoAudioInputDevice", "VuoAudioOutputDevice", "VuoAudioFrame", "VuoData",
								  "VuoCoordinateUnit", "VuoDistribution3d", "VuoDragEvent",
								  "VuoGridType",
								  "VuoHidControl", "VuoHidDevice",
								  "VuoImageFormat",
								  "VuoFont", "VuoMidiController", "VuoMidiInputDevice",
								  "VuoMidiNote", "VuoMidiOutputDevice", "VuoMidiPitchBend",
								  "VuoMultisample", "VuoNdiSource", "VuoBaudRate", "VuoParity",
								  "VuoOscInputDevice", "VuoOscOutputDevice",
								  "VuoRange",
								  "VuoRectangle",
								  "VuoRelativeTime", "VuoRoundingMethod",
								  "VuoSerialDevice", "VuoVertexAttribute", "VuoSyphonServerDescription",
								  "VuoTempoRange", "VuoNumberFormat", "VuoIconPosition", "VuoMovieFormat",
								  "VuoVideoFrame", "VuoVideoInputDevice",
								  "VuoTime", "VuoTimeUnit", "VuoTimeFormat", "VuoWeekday",
								  "VuoHorizontalAlignment", "VuoVerticalAlignment", "VuoAnchor"
							  ]
						  }
					  },
				 });

void nodeEvent
(
	VuoInputData(VuoList_VuoGenericType1) list1,
	VuoInputData(VuoList_VuoGenericType1) list2,
	VuoOutputData(VuoList_VuoGenericType1) sameValues,
	VuoOutputData(VuoList_VuoInteger) sameIndexes,
	VuoOutputData(VuoList_VuoInteger) differentIndexes
)
{
	*sameValues = VuoListCreate_VuoGenericType1();
	*sameIndexes = VuoListCreate_VuoInteger();
	*differentIndexes = VuoListCreate_VuoInteger();
	unsigned long count = VuoListGetCount_VuoGenericType1(list1);
	for (unsigned long i = 1; i <= count; ++i)
	{
		VuoGenericType1 data1 = VuoListGetValue_VuoGenericType1(list1, i);
		VuoGenericType1 data2 = VuoListGetValue_VuoGenericType1(list2, i);
		if (VuoGenericType1_areEqual(data1, data2))
		{
			VuoListAppendValue_VuoGenericType1(*sameValues, data1);
			VuoListAppendValue_VuoInteger(*sameIndexes, i);
		}
		else
		{
			VuoListAppendValue_VuoInteger(*differentIndexes, i);
		}
	}
}
